SystemOrganization addCategory: #'Xtreams-SubstreamsTests'!

TestCase subclass: #XTStitchingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-SubstreamsTests'!

!XTStitchingTest methodsFor: 'tests' stamp: 'MartinKobetic 1/11/2011 17:48'!
test2SimpleReadStreams

	| stream contents |
	stream := (1 to: 5) reading, (6 to: 7) reading.
	contents := stream rest.
	self assert: contents = (1 to: 7)! !

!XTStitchingTest methodsFor: 'tests' stamp: 'MartinKobetic 1/11/2011 18:10'!
test3SimpleReadStreams

	| stream contents |
	stream := (1 to: 5) reading, (6 to: 7) reading, (8 to: 10) reading.
	contents := stream rest.
	self assert: contents = (1 to: 10)! !

!XTStitchingTest methodsFor: 'tests' stamp: 'MartinKobetic 1/11/2011 18:10'!
test3SimpleReadStreamsPrepending

	| stream contents |
	stream := (1 to: 5) reading, ((6 to: 7) reading, (8 to: 10) reading).
	contents := stream rest.
	self assert: contents = (1 to: 10)! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testReadClosing
	| closing closed |
	self output write: #[ 1 2 3 4 5 6 7 8 9 ]; close.
	closed := 0.
	closing := (self input closing: [ closed := closed + 1 ]) slicing.

	self assert: (closing get read: 3) = #[ 1 2 3 ].
	self assert: (closing get read: 4) = #[ 4 5 6 7 ].
	self assert: closed = 1.
	self assert: (closing get read: 2) = #[ 8 9 ].
	self assert: closed = 2.
	self should: [closing get get] raise: Incomplete.
	self assert: closed = 3.
	self should: [closing get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testReadEndingBlock
	| substream ender |
	self output write: #[ 1 2 3 4 5 6 7 8 9 ]; close.
	ender := (self input ending: [:e | e = 4]) slicing.
	substream := ender get.
	self assert: (substream read: 3) = #[ 1 2 3 ].
	self should: [substream get] raise: Incomplete.
	substream := ender get.
	self assert: (substream read: 5) = #[ 5 6 7 8 9 ].
	self should: [substream get] raise: Incomplete.
	self should: [ender get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testReadEndingBlockPositioning
	| substream ender |
	self output write: #[ 1 2 3 4 5 6 7 8 9 ]; close.
	ender := (self input ending: [:e | e = 4]) slicing.
	substream := ender get.
	substream ++ 2.
	self assert: substream get = 3.
	self should: [substream ++ 3] raise: Incomplete.
	self should: [substream -- 2] raise: Error. "not positionable"
	substream := ender get.
	self assert: substream get = 5.
	substream -= 0.
	self should: [substream get] raise: Incomplete.
	self should: [ender get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testReadEndingBlockTail
	| substream ender |
	self output write: #[ 1 2 3 4 5 6 7 8 9 ]; close.
	ender := (self input ending: [:e | e = 4] inclusive: true) slicing.
	substream := ender get.
	self assert: (substream read: 4) = #[ 1 2 3 4 ].
	self should: [substream get] raise: Incomplete.
	self should: [substream get] raise: Incomplete.
	substream := ender get.
	self assert: (substream read: 5) = #[ 5 6 7 8 9 ].
	self should: [substream get] raise: Incomplete.
	self should: [ender get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testReadEndingCollection
	| substream ender |
	self output write: #[ 0 1 1 2 1 2 3 4 5 6 ]; close.
	ender := (self input ending: #[ 1 2 3 ]) slicing.
	substream := ender get.
	self assert: (substream read: 4) = #[ 0 1 1 2 ].
	self should: [substream get] raise: Incomplete.
	substream := ender get.
	self assert: (substream read: 3) = #[ 4 5 6 ].
	self should: [substream get] raise: Incomplete.
	self should: [ender get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testReadEndingCollectionPositioning
	| substream ender |
	self output write: #[ 0 1 1 2 1 2 3 4 5 6 ]; close.
	ender := (self input ending: #[ 1 2 3 ]) slicing.
	substream := ender get.
	substream ++ 3.
	self assert: substream get = 2.
	self should: [substream ++ 3] raise: Incomplete.
	self should: [substream -- 2] raise: Error. "not positionable"
	substream := ender get.
	self assert: substream get = 4.
	substream -= 0.
	self should: [substream get] raise: Incomplete.
	self should: [ender get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testReadEndingCollectionTail
	| substream ender |
	self output write: #[ 0 1 1 2 1 2 3 4 5 6 ]; close.
	ender := (self input ending: #[ 1 2 3 ] inclusive: true) slicing.
	substream := ender get.
	self assert: (substream read: 7) = #[ 0 1 1 2 1 2 3 ].
	self should: [substream get] raise: Incomplete.
	substream := ender get.
	self assert: (substream read: 3) = #[ 4 5 6 ].
	self should: [substream get] raise: Incomplete.
	self should: [ender get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testReadEndingObject
	| substream ender |
	self output write: #[ 1 2 3 4 5 6 7 8 9 ]; close.
	ender := (self input ending: 4) slicing.
	substream := ender get.
	self assert: (substream read: 3) = #[ 1 2 3 ].
	self should: [substream get] raise: Incomplete.
	substream := ender get.
	self assert: (substream read: 5) = #[ 5 6 7 8 9 ].
	self should: [substream get] raise: Incomplete.
	self should: [ender get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testReadEndingObjectPositioning
	| substream ender |
	self output write: #[ 1 2 3 4 5 6 7 8 9 ]; close.
	ender := (self input ending: 4) slicing.
	substream := ender get.
	substream ++ 2.
	self assert: substream get = 3.
	self should: [substream ++ 3] raise: Incomplete.
	self should: [substream -- 2] raise: Error. "not positionable"
	substream := ender get.
	self assert: substream get = 5.
	substream -= 0.
	self should: [substream get] raise: Incomplete.
	self should: [ender get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testReadEndingObjectTail
	| substream ender |
	self output write: #[ 1 2 3 4 5 6 7 8 9 ]; close.
	ender := (self input ending: 4 inclusive: true) slicing.
	substream := ender get.
	self assert: (substream read: 4) = #[ 1 2 3 4 ].
	self should: [substream get] raise: Incomplete.
	self should: [substream get] raise: Incomplete.
	substream := ender get.
	self assert: (substream read: 5) = #[ 5 6 7 8 9 ].
	self should: [substream get] raise: Incomplete.
	self should: [ender get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testReadLimiting
	| subinput limiter |
	self output write: #[ 1 1 1 2 2 2 ]; close.
	limiter := (self input limiting: 3) slicing.

	subinput := limiter get.
	self assert: (subinput read: 3) = #[ 1 1 1 ].
	self should: [subinput get] raise: Incomplete.

	subinput := limiter get.
	self assert: (subinput read: 3) = #[ 2 2 2 ].
	self should: [subinput get] raise: Incomplete.

	self should: [limiter get get] raise: Incomplete.
	self should: [limiter get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testReadLimitingPositioning
	| subinput limiter |
	self output write: #[ 1 1 1 2 2 2 ]; close.
	limiter := (self input limiting: 3) slicing.

	subinput := limiter get.
	subinput ++ 2.
	self assert: subinput rest = #[ 1 ].
	subinput isPositionable
		ifTrue: [ subinput -- 2.
			self assert: subinput rest = #[ 1 1 ].
			subinput += 1.
			self assert: subinput rest = #[ 1 1 ].
			subinput -= 2.
			self assert: subinput rest = #[ 1 1 ] ]
		ifFalse: [ self should: [ subinput -- 2 ] raise: Error ].
	self should: [subinput get] raise: Incomplete.

	subinput := limiter get.
	self assert: (subinput read: 3) = #[ 2 2 2 ].
	self should: [subinput get] raise: Incomplete.

	self should: [limiter get get] raise: Incomplete.
	self should: [limiter get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testReadStitchLimiting
"Note that a plain [ self input limiting: 3 ] reading stitching stream would never end because it keeps generating empty limiting: streams at the end of the input.
That's why additional measure is necessary to make sure the slice source eventually generates Incomplete.
" 
	| limiter wasEmpty |
	self output write: #[ 1 1 1 2 2 2 ]; close.
	wasEmpty := false.
	limiter := [
			wasEmpty ifTrue: [ Incomplete zero raise ]. wasEmpty := true.
			(self input doing: [ :e | wasEmpty := false ]) limiting: 3
		] reading stitching.

	self assert: limiter rest = #[ 1 1 1 2 2 2].
	self should: [limiter get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:46'!
testReadStitchingChunks
"Chunks are prefixed with size in the first byte. Below we have 3 chunks of size 1, 3 and 7, and terminating 0 chunk."

	| chunks contents stitched |
	chunks := (ByteArray withAll: (1 to: 14)), #[0].
	self output write: chunks; close.
	stitched := [ self input limiting: self input get ] reading stitching.
	contents := stitched rest.
	self assert: contents = #[2 4 5 6 8 9 10 11 12 13 14]! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 12/31/2010 01:42'!
testWriteClosing
	| closing suboutput |
	closing := (self output closing: [ :s | s put: 0 ]) slicing.

	suboutput := closing get.
	suboutput write: #[ 1 1 1 ]; close.

	suboutput := closing get.
	suboutput write: #[ 2 2 2 ]; close.
	closing close.

	self assert: (self input read: 8) = #[ 1 1 1 0 2 2 2 0 ]! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 12/31/2010 01:42'!
testWriteClosingPositioning
	| closing suboutput |

	"If we're on a non-positionable stream, there's no point trying to test substream positioning"
	self output isPositionable ifFalse: [^self].

	closing := (self output closing: [ :s | s put: 0 ]) slicing.

	suboutput := closing get.
	suboutput write: #[ 1 3 3 ].
	self assert: suboutput position = 3.
	suboutput -- 2.
	self assert: suboutput position = 1.
	suboutput write: #[ 1 1 ]; close.

	suboutput := closing get.
	suboutput write: #[ 2 2 3 ].
	suboutput += 1.
	self assert: suboutput position = 1.
	suboutput ++ 1.
	suboutput put: 2; close.

	closing close.

	self assert: (self input read: 8) = #[ 1 1 1 0 2 2 2 0 ]! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testWriteEndingBlock
	| ender |
	ender := (self output ending: [:e | e = 4]) slicing.
	self should: [ ender get write: #[ 1 2 3 4 5 6 7 8 9 ] ] raise: Incomplete.
	self shouldnt: [ ender get write: #[ 5 6 7 8 9 ] ] raise: Incomplete.
	ender close.
	self assert: (self input read: 8) = #[ 1 2 3 5 6 7 8 9 ].
	self should: [self input get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testWriteEndingBlockTail
	| ender |
	ender := (self output ending: [:e | e = 4] inclusive: true) slicing.
	self should: [ ender get write: #[ 1 2 3 4 5 6 7 8 9 ] ] raise: Incomplete.
	self shouldnt: [ ender get write: #[ 5 6 7 8 9 ] ] raise: Incomplete.
	ender close.
	self assert: (self input read: 9) = #[ 1 2 3 4 5 6 7 8 9 ].
	self should: [self input get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testWriteEndingCollection
	| ender |
	ender := (self output ending: #[ 1 2 3 ]) slicing.
	self should: [ ender get write: #[ 0 1 1 2 1 2 3 4 5 6 ] ] raise: Incomplete.
	self shouldnt: [ ender get write: #[ 4 5 6 ] ] raise: Incomplete.
	ender close.
	self assert: (self input read: 7) = #[ 0 1 1 2 4 5 6 ].
	self should: [self input get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testWriteEndingCollectionTail
	| ender |
	ender := (self output ending: #[ 1 2 3 ] inclusive: true) slicing.
	self should: [ ender get write: #[ 0 1 1 2 1 2 3 4 5 6 ] ] raise: Incomplete.
	self shouldnt: [ ender get write: #[ 4 5 6 ] ] raise: Incomplete.
	ender close.
	self assert: (self input read: 10) = #[ 0 1 1 2 1 2 3 4 5 6 ].
	self should: [self input get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testWriteEndingObject
	| ender |
	ender := (self output ending: 4) slicing.
	self should: [ ender get write: #[ 1 2 3 4 5 6 7 8 9 ] ] raise: Incomplete.
	self shouldnt: [ ender get write: #[ 5 6 7 8 9 ] ] raise: Incomplete.
	ender close.
	self assert: (self input read: 8) = #[ 1 2 3 5 6 7 8 9 ].
	self should: [self input get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testWriteEndingObjectTail
	| ender |
	ender := (self output ending: 4 inclusive: true) slicing.
	self should: [ ender get write: #[ 1 2 3 4 5 6 7 8 9 ] ] raise: Incomplete.
	self shouldnt: [ ender get write: #[ 5 6 7 8 9 ] ] raise: Incomplete.
	ender close.
	self assert: (self input read: 9) = #[ 1 2 3 4 5 6 7 8 9 ].
	self should: [self input get] raise: Incomplete! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testWriteLimiting
	| limiting suboutput |
	limiting := (self output limiting: 3) slicing.

	suboutput := limiting get.
	suboutput write: #[ 1 1 1 ].
	self should: [suboutput put: 1] raise: Incomplete.

	suboutput := limiting get.
	suboutput write: #[ 2 2 2 ].
	self should: [suboutput put: 2] raise: Incomplete.

	suboutput := limiting get.
	suboutput write: #[ 3 3 3 ].
	self should: [suboutput put: 3] raise: Incomplete.

	limiting close.
	self assert: (self input read: 9) = #[ 1 1 1 2 2 2 3 3 3 ]! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:53'!
testWriteLimitingPositioning
	| limiting suboutput |

	"If we're not on a positioning stream, there's no point testing substream positioning"
	self output isPositionable ifFalse: [^self].

	limiting := (self output limiting: 3) slicing.

	suboutput := limiting get.
	suboutput write: #[ 1 4 4 ].
	self assert: suboutput position = 3.
	self assert: suboutput length = 3.
	self assert: suboutput available = 0.
	suboutput -- 2.
	self assert: suboutput position = 1.
	self assert: suboutput length = 3.
	self assert: suboutput available = 2.
	suboutput write: #[ 1 1 ].
	self should: [suboutput put: 1] raise: Incomplete.

	suboutput := limiting get.
	suboutput write: #[ 2 2 3 ].
	suboutput += 1.
	self assert: suboutput position = 1.
	self assert: suboutput length = 3.
	self assert: suboutput available = 2.
	suboutput ++ 1.
	self assert: suboutput position = 2.
	self assert: suboutput length = 3.
	self assert: suboutput available = 1.
	suboutput put: 2.
	self should: [suboutput put: 2] raise: Incomplete.

	limiting close.
	self assert: (self input read: 6) = #[ 1 1 1 2 2 2 ]! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:47'!
testWriteStitchLimiting
	| limiting |
	limiting := [self output limiting: 3] reading stitching.

	limiting write: #[ 1 1 1 2 2 2 3 3 3 ].
	limiting close.

	self assert: (self input read: 9) = #[ 1 1 1 2 2 2 3 3 3 ]! !

!XTFiniteReadingWritingTests methodsFor: '*Xtreams-SubstreamsTests' stamp: 'MartinKobetic 1/11/2011 17:47'!
testWriteStitchingChunks
"Chunks are prefixed with size in the first byte. Below we have 3 chunks of size 1, 3 and 7, and terminating 0 chunk."

	| contents buffer |
	buffer := XTRingBuffer on: (ByteArray new: 3).
	[	(buffer writing limiting: buffer cacheSize)
			closeBlock: [ self output put: buffer readSize; write: buffer ];
			yourself
	] reading stitching
		write: (1 to: 7); flush;
		write: (8 to: 15); close.
	self output close.
	contents := self input rest.
	self assert: contents =
		#[	3 1 2 3 "first chunk"
			3 4 5 6 "second chunk"
			1 7		"short chunk after flush"
			3 8 9 10 "full chunk"
			3 11 12 13 "full chunk"
			2 14 15	"final short chunk" ]! !
